Entity = {
  
  IdCounter = 0
  
  }

function Entity:create()
  self.IdCounter = self.IdCounter + 1
  
  local ent = {
    UUID = self.IdCounter,
    Components = {}
    }
  
  function ent:addComponent(comp)
    self.Components[comp.name] = comp
  end
  
  function ent:removeComponent(comp)
    self.Components[comp.name] = nil
  end
  
  function ent:broadcast(message, ...)
    for k, comp in pairs(self.Components) do
      comp:trigger(message, ...)
    end
  end
  
  return ent
end