require('components.positioncomponent')
require('components.cameracomponent')
require('components.mousecomponent')

ComponentGenerator = {
  
  Position = function ()
    return PositionComponent:create()
  end,
  
  Camera = function ()
    return CameraComponent:create()
  end,
  
  Mouse = function ()
    return MouseComponent:create()
  end,
  
  }

function ComponentGenerator:generate(name)
  return self[name]()
end