Vector = {}

function Vector:new(x,y)
  self.__index = self
  return setmetatable({
    X = x,
    Y = y,
  }, self)
end

function Vector:hasValue()
  return (self.X ~= nil and self.X ~= 0) or (self.Y ~= nil and self.Y ~= 0)
end

function Vector:inRange(v1, v2, r)
  return v1 >= v2 - r and v1 <= v2 + r
end

function Vector:empty()
  self.X = 0
  self.Y = 0
end