require('managers.systemmanager')
require('managers.componentmanager')
require('managers.entitymanager')

SCALE = 2

GameManager = {
  
  CurrentState = 'play'
  
}

function GameManager:load()
  ComponentManager:load()
  EntityManager:load()
  SystemManager:load()
end

function GameManager:update(dt)
  SystemManager:update(dt)
end

function GameManager:draw()
  love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
  
  SystemManager:draw()
end

function GameManager:handleInput()
  
end